#property copyright "Copyright 2013, papaklass."
#property link      "http://www.mql4.com/ru/users/papaklass"
#property library

//+----------------------------------------------------------------------------+

//   ,    1 
double   GetMarginForOpening( int dir, string smb ){
   //    
   int leverage = AccountLeverage();
   //    
   double contract = MarketInfo( smb, MODE_LOTSIZE );
   //  
   string accCurrency = AccountCurrency();
   //  
   string marginCurrency = StringSubstr( StringTrimLeft( smb ), 0, 3 );
   //  
   string profitCurrency = StringSubstr( StringTrimLeft( smb ), 3, 3 );
   //  
   string calcCurrency ="";
   //  - true,  - false
   double prc;
   
   //   
   if( profitCurrency == accCurrency ){  // XXXUSD - 
      calcCurrency = smb;
   
      //     
      prc = Dbl_If( dir == OP_BUY, MarketInfo( calcCurrency, MODE_ASK ),
                                   MarketInfo( calcCurrency, MODE_BID ) );
   }
   
   if( marginCurrency == accCurrency ){  // USDXXX - 
      calcCurrency = smb;
      prc = 1.0;
   }

   if( calcCurrency == "" ){
      //     
      double crossPrice =
         Dbl_If( dir == OP_BUY, MarketInfo( smb, MODE_ASK ),
                                MarketInfo( smb, MODE_BID ) );
      calcCurrency = GetSymbolByCurrencies(profitCurrency, accCurrency);
      
      prc = 
         Dbl_If(dir == OP_BUY, crossPrice * MarketInfo(calcCurrency, MODE_ASK),
                               crossPrice * MarketInfo(calcCurrency, MODE_BID)); 
      
      if(calcCurrency == "NULL"){
         calcCurrency = GetSymbolByCurrencies(accCurrency, profitCurrency);
      
         prc = 
            Dbl_If(dir == OP_BUY, crossPrice / MarketInfo(calcCurrency, MODE_ASK),
                                  crossPrice / MarketInfo(calcCurrency, MODE_BID)); 
      }
      
   }
   
   if( leverage != 0 && prc != 0 && contract != 0){
      return( NormalDbl(  prc * contract  / leverage, 2) );
   }

   return( -1 );
}//----------------------------------------------------------------------------+

//      (base)   (profit)
string   GetSymbolByCurrencies( string baseCurrency, string accCurrency ){
   //  
   string calcCurrency = "" + baseCurrency + accCurrency;
   
   if( MarketInfo( calcCurrency, MODE_ASK) != 0 ){ return( calcCurrency ); }

   return( "NULL" );
}//----------------------------------------------------------------------------+

//    Double   
// -1   
double NormalDbl( double d, int n = -1 ){
   int dgt = MarketInfo( Symbol(), MODE_DIGITS );
   if( n <  0 ){ return( NormalizeDouble( d, dgt ) ); }
   if( n >= 0 ){ return( NormalizeDouble( d, n ) ); }
   return( -1 );
}//----------------------------------------------------------------------------+

//   If_True  If_False    
// Condition
double Dbl_If( bool Condition, double If_True, double If_False ){
   if ( Condition ) return( If_True );
   else             return( If_False );
}//----------------------------------------------------------------------------+

